Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/CodeEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/CodeEditor.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/CodeEditor.cs	(revision 11933)
@@ -61,5 +61,4 @@
 
     private AssemblyLoader assemblyLoader;
-    private ILanguageFeatures languageFeatures;
     private TextMarkerService textMarkerService;
 
@@ -191,5 +190,4 @@
       TextEditor.TextArea.TextView.LineTransformers.Add(textMarkerService);
       TextEditor.TextArea.TextView.Services.AddService(typeof(ITextMarkerService), textMarkerService);
-
       #endregion
 
@@ -441,8 +439,8 @@
       switch (TextEditorSyntaxHighlighting) {
         case "XML":
-          languageFeatures = new XmlLanguageFeatures(this);
+          XmlLanguageFeatures.Apply(this);
           break;
         default:
-          languageFeatures = new CSharpLanguageFeatures(this);
+          CSharpLanguageFeatures.Apply(this);
           break;
       }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/HeuristicLab.CodeEditor-3.4.csproj
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/HeuristicLab.CodeEditor-3.4.csproj	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/HeuristicLab.CodeEditor-3.4.csproj	(revision 11933)
@@ -158,5 +158,4 @@
     <Compile Include="LanguageFeatures\Helpers\CSharpParsingHelpers.cs" />
     <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CompletionData\EntityCompletionData.cs" />
-    <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CompletionData\ImportCompletionData.cs" />
     <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CompletionData\VariableCompletionData.cs" />
     <Compile Include="LanguageFeatures\Interfaces\ICodeFoldingStrategy.cs" />
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CSharpLanguageFeatures.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CSharpLanguageFeatures.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CSharpLanguageFeatures.cs	(revision 11933)
@@ -25,4 +25,8 @@
       : base(codeEditor, new CSharpCodeFoldingStrategy(codeEditor), new CSharpCodeCompletionStrategy(codeEditor)) {
     }
+
+    public static ILanguageFeatures Apply(CodeEditor codeEditor) {
+      return new CSharpLanguageFeatures(codeEditor);
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionDataFactory.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionDataFactory.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionDataFactory.cs	(revision 11933)
@@ -105,6 +105,5 @@
 
     public ICompletionData CreateImportCompletionData(IType type, bool useFullName, bool addForTypeCreation) {
-      var typeDef = type.GetDefinition();
-      return new ImportCompletionData(typeDef, context.TypeResolveContextAtCaret, useFullName);
+      return null;
     }
 
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpOverloadProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpOverloadProvider.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpOverloadProvider.cs	(revision 11933)
@@ -161,7 +161,5 @@
     #endregion
 
-
     public event PropertyChangedEventHandler PropertyChanged;
-
     private void OnPropertyChanged(string propertyName) {
       var args = new PropertyChangedEventArgs(propertyName);
Index: unk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/ImportCompletionData.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/ImportCompletionData.cs	(revision 11932)
+++ 	(revision )
@@ -1,40 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using ICSharpCode.NRefactory.CSharp.Refactoring;
-using ICSharpCode.NRefactory.CSharp.Resolver;
-using ICSharpCode.NRefactory.CSharp.TypeSystem;
-using ICSharpCode.NRefactory.TypeSystem;
-
-namespace HeuristicLab.CodeEditor {
-  internal class ImportCompletionData : EntityCompletionData {
-    public ImportCompletionData(ITypeDefinition typeDefinition, CSharpTypeResolveContext contextAtCaret, bool useFullName)
-      : base(typeDefinition) {
-      Description = string.Format("using {0};", typeDefinition.Namespace);
-      if (useFullName) {
-        var builder = new TypeSystemAstBuilder(new CSharpResolver(contextAtCaret));
-        CompletionText = builder.ConvertType(typeDefinition).ToString();
-      } else {
-        CompletionText = typeDefinition.Namespace;
-      }
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionStrategy.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionStrategy.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionStrategy.cs	(revision 11933)
@@ -40,5 +40,5 @@
     }
 
-    public virtual void RunBackgroundParser() {
+    public virtual void Initialize() {
       backgroundParser.Start();
     }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingStrategy.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingStrategy.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingStrategy.cs	(revision 11933)
@@ -22,20 +22,8 @@
 using System.Linq;
 using CSharpBinding.Parser;
-using ICSharpCode.NRefactory.CSharp;
-using ICSharpCode.NRefactory.TypeSystem;
 
 namespace HeuristicLab.CodeEditor {
   internal class CSharpCodeFoldingStrategy : CodeFoldingStrategy {
-    private IProjectContent projectContent = new CSharpProjectContent();
-
-    public CSharpCodeFoldingStrategy(CodeEditor codeEditor)
-      : base(codeEditor) {
-      codeEditor.InternalAssembliesLoaded += (sender, args) => {
-        projectContent = projectContent.AddAssemblyReferences(args.Value);
-      };
-      codeEditor.InternalAssembliesUnloaded += (sender, args) => {
-        projectContent = projectContent.RemoveAssemblyReferences(args.Value);
-      };
-    }
+    public CSharpCodeFoldingStrategy(CodeEditor codeEditor) : base(codeEditor) { }
 
     protected override CodeFoldingResult GetCodeFoldingResult(out int firstErrorOffset) {
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeCompletionStrategy.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeCompletionStrategy.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeCompletionStrategy.cs	(revision 11933)
@@ -23,5 +23,5 @@
   internal interface ICodeCompletionStrategy {
     void DoCodeCompletion(bool controlSpace);
-    void RunBackgroundParser();
+    void Initialize();
   }
 }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/LanguageFeatures.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/LanguageFeatures.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/LanguageFeatures.cs	(revision 11933)
@@ -63,5 +63,5 @@
 
     private void LoadedHandler(object sender, EventArgs e) {
-      codeCompletionStrategy.RunBackgroundParser();
+      codeCompletionStrategy.Initialize();
     }
 
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/XmlLanguageFeatures.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/XmlLanguageFeatures.cs	(revision 11932)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/XmlLanguageFeatures.cs	(revision 11933)
@@ -25,4 +25,8 @@
       : base(codeEditor, new XmlCodeFoldingStrategy(codeEditor), null) {
     }
+
+    public static ILanguageFeatures Apply(CodeEditor codeEditor) {
+      return new XmlLanguageFeatures(codeEditor);
+    }
   }
 }