Index: /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/BonferroniHolmUnitTests.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/BonferroniHolmUnitTests.cs	(revision 11940)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/BonferroniHolmUnitTests.cs	(revision 11941)
@@ -28,4 +28,6 @@
   public class BonferroniHolmUnitTest {
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void BonferroniHolmUnitTest1() {
       /* example taken from 
@@ -53,4 +55,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void BonferroniHolmUnitTest2() {
       /* example taken from 
@@ -78,4 +82,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void BonferroniHolmUnitTest3() {
       // comparison with R's p.adjust(p, "holm") method
@@ -92,4 +98,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void BonferroniHolmUnitTest4() {
       // comparison with R's p.adjust(p, "holm") method
@@ -106,4 +114,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void BonferroniHolmUnitTest5() {
       // comparison with R's p.adjust(p, "holm") method
Index: /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/ConfidenceIntervalsTests.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/ConfidenceIntervalsTests.cs	(revision 11940)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/ConfidenceIntervalsTests.cs	(revision 11941)
@@ -34,4 +34,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void ConfidenceIntervalsTest1() {
       var result = z.ConfidenceIntervals(0.98);
@@ -41,4 +43,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void ConfidenceIntervalsTest2() {
       //comparison with R's t.test(..)
@@ -49,4 +53,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void ConfidenceIntervalsTest3() {
       //comparison with R's t.test(..)
@@ -57,4 +63,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void ConfidenceIntervalsTest4() {
       //comparison with R's t.test(..)
Index: /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/EffectSizeUnitTests.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/EffectSizeUnitTests.cs	(revision 11940)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/EffectSizeUnitTests.cs	(revision 11941)
@@ -32,4 +32,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void CohensdTest1() {
       //compared to R lsr package/cohenD(..)
@@ -39,4 +41,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void CohensdTest2() {
       //compared to R lsr package/cohenD(..)
@@ -46,4 +50,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void HedgesGTest1() {
       //compared to R effsize package/cohen.d(..,hedges.correction=TRUE)
@@ -53,4 +59,6 @@
 
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void HedgesGTest2() {
       //compared to R effsize package/cohen.d(..,hedges.correction=TRUE)
Index: /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/KruskalWallisUnitTests.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/KruskalWallisUnitTests.cs	(revision 11940)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/KruskalWallisUnitTests.cs	(revision 11941)
@@ -30,4 +30,6 @@
     //tests the sample data from R's Kruskal.Test() help page
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void KruskalWallisTest1() {
       double[][] data = new double[3][];
@@ -41,4 +43,6 @@
     //compares groups of uniformly distributed random variables
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void KruskalWallisTest2() {
       double[][] data = new double[3][];
@@ -67,4 +71,6 @@
     //compares groups of normally distributed random variables
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void KruskalWallisTest3() {
       double[][] data = new double[3][];
@@ -115,4 +121,6 @@
     //compares groups of normally and uniformly distributed random variables
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void KruskalWallisTest4() {
       double[][] data = new double[3][];
@@ -156,4 +164,6 @@
     //compares groups containing the same random variables
     [TestMethod]
+    [TestCategory("Analysis.Statistics")]
+    [TestProperty("Time", "short")]
     public void KruskalWallisTest5() {
       double[][] data = new double[4][];