Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncoding.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IEncoding.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncoding.cs	(revision 11949)
@@ -25,5 +25,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface IEncoding : IParameterizedNamedItem {
     ISolutionCreator SolutionCreator { get; set; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncodingOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IEncodingOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncodingOperator.cs	(revision 11949)
@@ -22,5 +22,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface IEncodingOperator : IOperator {
     ILookupParameter<IEncoding> EncodingParameter { get; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiEncodingOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IMultiEncodingOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiEncodingOperator.cs	(revision 11949)
@@ -22,5 +22,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface IMultiEncodingOperator : IOperator {
     void AddEncoding(IEncoding encoding);
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IMultiObjectiveProblemDefinition.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs	(revision 11949)
@@ -23,5 +23,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface IMultiObjectiveProblemDefinition : IProblemDefinition {
     bool[] Maximization { get; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IProblemDefinition.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/IProblemDefinition.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IProblemDefinition.cs	(revision 11949)
@@ -22,5 +22,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface IProblemDefinition {
     IEncoding Encoding { get; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveMoveOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/ISingleObjectiveMoveOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveMoveOperator.cs	(revision 11949)
@@ -21,5 +21,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface ISingleObjectiveMoveOperator : IMoveOperator {
   }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/ISingleObjectiveProblemDefinition.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs	(revision 11949)
@@ -24,5 +24,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   public interface ISingleObjectiveProblemDefinition : IProblemDefinition {
     bool Maximization { get; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveAnalysisOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/internal/IMultiObjectiveAnalysisOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveAnalysisOperator.cs	(revision 11949)
@@ -22,7 +22,6 @@
 using System;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   internal interface IMultiObjectiveAnalysisOperator : IEncodingOperator, IAnalyzer {
     Action<Individual[], double[][], ResultCollection, IRandom> AnalyzeAction { get; set; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveEvaluationOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/internal/IMultiObjectiveEvaluationOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveEvaluationOperator.cs	(revision 11949)
@@ -24,5 +24,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   internal interface IMultiObjectiveEvaluationOperator : IMultiObjectiveEvaluator, IEncodingOperator {
     Func<Individual, IRandom, double[]> EvaluateFunc { get; set; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/INeighborBasedOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/internal/INeighborBasedOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/INeighborBasedOperator.cs	(revision 11949)
@@ -24,5 +24,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   internal interface INeighborBasedOperator : IEncodingOperator {
     Func<Individual, IRandom, IEnumerable<Individual>> GetNeighborsFunc { get; set; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveAnalysisOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/internal/ISingleObjectiveAnalysisOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveAnalysisOperator.cs	(revision 11949)
@@ -24,5 +24,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   internal interface ISingleObjectiveAnalysisOperator : IEncodingOperator {
     Action<Individual[], double[], ResultCollection, IRandom> AnalyzeAction { get; set; }
Index: branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveEvaluationOperator.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable/3.3/Interfaces/internal/ISingleObjectiveEvaluationOperator.cs	(revision 11885)
+++ branches/ProgrammableProblem/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveEvaluationOperator.cs	(revision 11949)
@@ -24,5 +24,5 @@
 using HeuristicLab.Optimization;
 
-namespace HeuristicLab.Problems.Programmable {
+namespace HeuristicLab.Optimization {
   internal interface ISingleObjectiveEvaluationOperator : ISingleObjectiveEvaluator, IEncodingOperator {
     Func<Individual, IRandom, double> EvaluateFunc { get; set; }